package transportgrpc

import (
	grpcerr "git.perx.ru/perxis/perxis-go/pkg/errors/grpc"
	"git.perx.ru/perxis/perxis-go/pkg/members"
	"git.perx.ru/perxis/perxis-go/pkg/members/transport"
	pb "git.perx.ru/perxis/perxis-go/proto/members"
	grpckit "github.com/go-kit/kit/transport/grpc"
)

func NewServer(svc members.Members, opts ...grpckit.ServerOption) pb.MembersServer {
	eps := transport.Endpoints(svc)
	eps = transport.EndpointsSet{
		GetEndpoint:               grpcerr.ServerMiddleware(eps.GetEndpoint),
		ListMembersEndpoint:       grpcerr.ServerMiddleware(eps.ListMembersEndpoint),
		ListOrganizationsEndpoint: grpcerr.ServerMiddleware(eps.ListOrganizationsEndpoint),
		RemoveEndpoint:            grpcerr.ServerMiddleware(eps.RemoveEndpoint),
		SetEndpoint:               grpcerr.ServerMiddleware(eps.SetEndpoint),
	}
	return NewGRPCServer(&eps, opts...)
}
