package transportgrpc

import (
	grpcerr "git.perx.ru/perxis/perxis-go/pkg/errors/grpc"
	"git.perx.ru/perxis/perxis-go/pkg/users"
	"git.perx.ru/perxis/perxis-go/pkg/users/transport"
	pb "git.perx.ru/perxis/perxis-go/proto/users"
	grpckit "github.com/go-kit/kit/transport/grpc"
)

func NewServer(svc users.Users, opts ...grpckit.ServerOption) pb.UsersServer {
	eps := transport.Endpoints(svc)
	eps = transport.EndpointsSet{
		CreateEndpoint:        grpcerr.ServerMiddleware(eps.CreateEndpoint),
		DeleteEndpoint:        grpcerr.ServerMiddleware(eps.DeleteEndpoint),
		FindEndpoint:          grpcerr.ServerMiddleware(eps.FindEndpoint),
		GetByIdentityEndpoint: grpcerr.ServerMiddleware(eps.GetByIdentityEndpoint),
		GetEndpoint:           grpcerr.ServerMiddleware(eps.GetEndpoint),
		UpdateEndpoint:        grpcerr.ServerMiddleware(eps.UpdateEndpoint),
	}
	return NewGRPCServer(&eps, opts...)
}
